=begin
#Notifo API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.26
=end

module Notifo
  class NotificationsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Confirms the user notifications for the current user.
    # @param body The request object.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def notifications_confirm(body, opts = {})
      notifications_confirm_with_http_info(body, opts)
      nil
    end

    # Confirms the user notifications for the current user.
    # @param body The request object.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def notifications_confirm_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: NotificationsApi.notifications_confirm ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling NotificationsApi.notifications_confirm"
      end
      # resource path
      local_var_path = '/api/me/notifications/handled'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(body) 

      return_type = opts[:return_type] 

      auth_names = opts[:auth_names] || []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: NotificationsApi#notifications_confirm\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Query archhived user notifications of the current user.
    # @param [Hash] opts the optional parameters
    # @return [ListResponseDtoOfNotificationDto]
    def notifications_get_archive(opts = {})
      data, _status_code, _headers = notifications_get_archive_with_http_info(opts)
      data
    end

    # Query archhived user notifications of the current user.
    # @param [Hash] opts the optional parameters
    # @return [Array<(ListResponseDtoOfNotificationDto, Integer, Hash)>] ListResponseDtoOfNotificationDto data, response status code and response headers
    def notifications_get_archive_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: NotificationsApi.notifications_get_archive ...'
      end
      # resource path
      local_var_path = '/api/me/notifications/archive'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'ListResponseDtoOfNotificationDto' 

      auth_names = opts[:auth_names] || []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: NotificationsApi#notifications_get_archive\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Query user notifications of the current user.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :query The optional query to search for items.
    # @option opts [Integer] :take The number of items to return.
    # @option opts [Integer] :skip The number of items to skip.
    # @return [ListResponseDtoOfNotificationDto]
    def notifications_get_notifications(opts = {})
      data, _status_code, _headers = notifications_get_notifications_with_http_info(opts)
      data
    end

    # Query user notifications of the current user.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :query The optional query to search for items.
    # @option opts [Integer] :take The number of items to return.
    # @option opts [Integer] :skip The number of items to skip.
    # @return [Array<(ListResponseDtoOfNotificationDto, Integer, Hash)>] ListResponseDtoOfNotificationDto data, response status code and response headers
    def notifications_get_notifications_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: NotificationsApi.notifications_get_notifications ...'
      end
      # resource path
      local_var_path = '/api/me/notifications'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'query'] = opts[:'query'] if !opts[:'query'].nil?
      query_params[:'take'] = opts[:'take'] if !opts[:'take'].nil?
      query_params[:'skip'] = opts[:'skip'] if !opts[:'skip'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'ListResponseDtoOfNotificationDto' 

      auth_names = opts[:auth_names] || []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: NotificationsApi#notifications_get_notifications\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
